public class Chroma
{
    // Signal Chain
    adc => HPF hpf => LPF lpf => FFT fft => blackhole;
    hpf.freq(100);
    lpf.freq(5000);
    //Sinosc => FFT fft => blackhole;
    //adc => dac; // for testing
    //adc => dac;
    dac.gain(1);
    
    //osc.gain(1);
    //880 => float fq;
    //fq => osc.freq;


    // Global Parameters
    second / samp => global float fs;
    4096 => global int size => fft.size;
    global float pitchChroma[12];
    ["C ", "C#", "D ", "D#", "E ", "F ", "F#", "G ", "G#", "A ", "A#", "B "] @=> string pitchNames[];


    fun int freqToBin(float freq)
    {
        (fs / size) => float binWidth; // FFT bin width
        (freq / binWidth) $ int => int binNumber; // get frequency bin index
        return binNumber;
    }

    fun float[] getChroma()
    {
        // Store the FFT here
        float f[size/2];
        
        // Take FFT
        fft.upchuck().fvals() @=> f;
        
        // Compute Pitches, 100-5000Hz, HPCP
        // Examine bins [8, 464]
        // Sum up the power of the frequencies
        for (0 => int i; i < 12; i++)
        {
            // First pitch is C, midi 36
            36 + i => Std.mtof => float freq;
            1 => float acc;
            while (freq < 5000)
            {
                // Get magnitude of FFT spectrum for frequency
                f[freqToBin(freq)] => float mag;
                // Fudge the scaling
                Math.sqrt(mag * 800) => mag;
                if (mag > 0.8)
                {
                    (mag+1) *=> acc;
                }
                // Next octave up for next harmonic 
                2 *=> freq;
            }

            // Store accumulated power in pitch array
            (acc - 1) => pitchChroma[i];
            //<<< pitchNames[i], pitchChroma[i] >>>;
        }

        return pitchChroma;
    }
}